#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int *readintegers(char *filename, int *arr, int *length, int *numread)
{
	int res,i;
	FILE *f;
	
	*numread = 0;
	f = fopen(filename, "r");
	while ((res=fscanf(f,"%i\n", &i)) != EOF) {
		if (*numread >= *length) {
			arr = (int *) realloc (arr, sizeof(int)*(*length+100));
			*length += 100;
		}
		arr[(*numread)++] = i;
	}
	fclose(f);
/*        for ( i=0; i < *numread; i++) {
               printf("%i ",arr[i]);
        }*/
		
	return arr;
}


main(int argc, char *argv[])
{
	const int tag = 50;
	int id, ntasks, source_id, dest_id, rc, i;
	MPI_Status status;
	int msg[2];

	int size;
	int *arr;
	int result=0;
	char *filename;
	int numread,length;

rc = MPI_Init(&argc, &argv);


if (rc != MPI_SUCCESS) {

	printf("MPI Init failed\n");
	exit(1);
}

rc = MPI_Comm_size(MPI_COMM_WORLD, &ntasks);
rc = MPI_Comm_rank(MPI_COMM_WORLD, &id);


						
if ( id != 0 ) { 


	dest_id = 0;

	rc = MPI_Recv(&size, 1, MPI_INT, dest_id, tag, MPI_COMM_WORLD, &status);
	arr = malloc(sizeof(int)*size);
	rc = MPI_Recv(arr, size, MPI_INT, dest_id, tag, MPI_COMM_WORLD, &status);
        for (i=0;i<size;i++) {
                result+=arr[i];
        }
		
	rc = MPI_Send(&result, 1, MPI_INT, dest_id, tag, MPI_COMM_WORLD);

} else { 
int res,start,sublength;

	filename = argv[1];
       arr = malloc(sizeof(int)*10);
       length = 10;
       arr = readintegers(filename, arr, &length, &numread);

for (i=0;i < ntasks -1; i++) {

	start = numread/(ntasks-1)*i;
	sublength = numread/(ntasks-1);
	if (i == ntasks - 2 )
		sublength += numread % (ntasks-1);
	printf("%i %i %i\n",i+1,start,sublength);
	rc = MPI_Send(&sublength, 1, MPI_INT, i+1, tag, MPI_COMM_WORLD);
	rc = MPI_Send(arr+start, sublength, MPI_INT, i+1, tag, MPI_COMM_WORLD);
	
}

for (i=0;i < ntasks -1; i++) {
	rc = MPI_Recv(&res, 1, MPI_INT,  MPI_ANY_SOURCE, tag, MPI_COMM_WORLD, &status);
	result+= res;
}
printf("Result is %i\n",result);

}

MPI_Finalize();

exit(0);

}
