#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define _REENTRANT
#include<pthread.h>



void *sub(void *);



typedef struct threaddata threaddata;

struct threaddata {
	int *buf;
	pthread_cond_t *writecond;
	pthread_mutex_t *writemutex;
	pthread_cond_t *readcond;
	pthread_mutex_t *readmutex;
	int len;
	int isproducer;
	int number;
        pthread_cond_t *emptycond;
        pthread_mutex_t *emptymutex;
        pthread_cond_t *fullcond;
        pthread_mutex_t *fullmutex;
					
};

int main(int argc, char *argv[])
{
	int *arr;
	
	int length,producers,consumers;
	int i,j;
	pthread_t *threads;
	threaddata *data;

        pthread_cond_t emptycond;
        pthread_mutex_t emptymutex;
        pthread_cond_t fullcond;
        pthread_mutex_t fullmutex;

        pthread_cond_t *writecond;
        pthread_mutex_t *writemutex;
        pthread_cond_t *readcond;
        pthread_mutex_t *readmutex;
					
					

	if (argc != 4) {
		printf("Usage: prog producers consumers length\n");
		return 1;
	}
	producers = atoi(argv[1]);
	consumers = atoi(argv[2]);
	length = atoi(argv[3]);
	
	arr = malloc(length*sizeof(int));
	for (i=0;i<length;i++)
		arr[i] = 0;
	
	threads = (pthread_t *)malloc((producers+consumers)*sizeof(pthread_t));
	data = (threaddata *)malloc((producers+consumers)*sizeof(threaddata));

	printf("This is main thread\n");

	pthread_mutex_init(&emptymutex,NULL);
	pthread_mutex_init(&fullmutex,NULL);
	pthread_cond_init(&emptycond,NULL);
	pthread_cond_init(&fullcond,NULL);

	readmutex = (pthread_mutex_t *)malloc(length*sizeof(pthread_mutex_t));
	writemutex = (pthread_mutex_t *)malloc(length*sizeof(pthread_mutex_t));
	readcond = (pthread_cond_t *)malloc(length*sizeof(pthread_cond_t));
	writecond = (pthread_cond_t *)malloc(length*sizeof(pthread_cond_t));
	
	for (i=0;i<length;i++) {
		pthread_mutex_init(&readmutex[i],NULL);
		pthread_mutex_init(&writemutex[i],NULL);
		pthread_cond_init(&readcond[i],NULL);
		pthread_cond_init(&writecond[i],NULL);
	}
	
	for (i=0;i<producers+consumers;i++) {
		data[i].buf = arr;
		data[i].len = length;
		data[i].number = i;
		data[i].readmutex = readmutex;
		data[i].writemutex = writemutex;
		data[i].readcond = readcond;
		data[i].writecond = writecond;
		data[i].emptymutex = &emptymutex;
		data[i].fullmutex = &fullmutex;
		data[i].emptycond = &emptycond;
		data[i].fullcond = &fullcond;
		if (i<producers)
			data[i].isproducer = 1;
		else 
			data[i].isproducer = 0;

	}
	
	for (i=0;i<producers+consumers;i++) {
		if (pthread_create(&threads[i], NULL, sub, &data[i] ))
		         fprintf(stderr, "Can't create thread\n"), exit(1);
		}

	printf("Main thread still\n");

	for (i=0;i<producers+consumers;i++) {
		if (pthread_join(threads[i], NULL)!=0) {perror("Join error\n"); exit(-1);}
        }

}


void * sub(void *arg)
{
	threaddata *data = (threaddata *) arg;
	int me;
	int i,j;
	int start, stop;

	me = pthread_self();

	printf("This is thread %i\n", me);


	if (data->isproducer) {
		for (i=0;i<20;i++) {
			sleep(rand() % 5);
tryagain:			
			pthread_mutex_lock(data->fullmutex);
			printf("Thread %i producing good %i\n",data->number,i);
			for (j=0;j<data->len;j++) {
				pthread_mutex_lock(&data->writemutex[i]);
				if ((data->buf)[j] == 0) {
					(data->buf)[j]++;
					printf("Thread %i produced good %i at position %i\n", data->number, i, j);
					pthread_cond_broadcast(data->emptycond);
					pthread_mutex_unlock(&data->writemutex[i]);
					pthread_mutex_unlock(data->emptymutex);
					break;
				}
				pthread_mutex_unlock(&data->writemutex[i]);
				pthread_mutex_unlock(data->emptymutex);
			}
			if (j == data->len) {
				printf("Thread %i: storage full, waiting for consuming\n", data->number);
				pthread_cond_wait(data->fullcond,data->fullmutex);
				pthread_mutex_unlock(data->fullmutex);
				goto tryagain;
			}
			pthread_mutex_unlock(data->fullmutex);
		}
	} else {
		for (i=0;i<20;i++) {
			j = rand() % 10;
/*			printf("%i",j);*/
			sleep(j);
tryagain2:
			pthread_mutex_lock((data->emptymutex));
			pthread_mutex_lock((data->fullmutex));
			printf("Thread %i consuming good %i\n",data->number,i);
			for (j=0;j<data->len;j++) {
                                pthread_mutex_lock(&data->readmutex[i]);
                                if ((data->buf)[j] == 1) {
                                        (data->buf)[j]--;
                                        printf("Thread %i consumed good %i at position %i\n", data->number, i, j);
 		                        pthread_cond_broadcast(data->fullcond);
                                        pthread_mutex_unlock(&data->readmutex[i]);
					pthread_mutex_unlock(data->fullmutex);
                                        break;
										                                }
                                pthread_mutex_unlock(&data->readmutex[i]);
				pthread_mutex_unlock(data->fullmutex);
										                        }
                        if (j == data->len) {
                                printf("Thread %i: storage empty, waiting for producing\n", data->number);
                                pthread_cond_wait(data->emptycond,data->emptymutex);
                                pthread_mutex_unlock(data->emptymutex);
                                goto tryagain2;
										                        }
                        pthread_mutex_unlock(data->emptymutex);
                }
	}		
	printf("thread %i exiting\n",data->number);
	return NULL;
}
		       
				       
